import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;

import javax.swing.JFrame;

public class Tetris_002{
	JFrame f;//メインウィンドウ
	Canvas canvas;//描画領域
	Image image;//バッファ領域（ダブルバッファリング用）

	Graphics fg;//描画領域用描画オブジェクト（グラフィックスコンテキスト）
	Graphics bg;//ダブルバッファリング用描画オブジェクト（グラフィックスコンテキスト）

	final int FIELD_ROWS=21;//フィールド幅
	final int FIELD_COLS=12;//フィールド高さ
	final int CELL_SIZE=28;//正方形（セル）のサイズ

	int[][] field=new int[FIELD_ROWS][FIELD_COLS];//フィールド用配列
	int[][] block;//ブロック用配列
	int x;//ブロックのx座標
	int y;//ブロックのy座標

	int screenW;//ウィンドウの幅
	int screenH;//ウィンドウの高さ

	public Tetris_002(){
		//画面サイズの設定
		screenW=FIELD_COLS*CELL_SIZE;
		screenH=FIELD_ROWS*CELL_SIZE;

		//フレームの設定
		f=new JFrame();
		f.setTitle("Tetris");
		f.setSize(screenW,screenH);
		f.setResizable(false);//ウィンドウサイズを変更不可に設定
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.setVisible(true);

		//描画領域の設定
		canvas=new Canvas();
		canvas.setSize(screenW,screenH);
		f.add(canvas);

		//描画領域のサイズ調整
        canvas.setPreferredSize(new Dimension(screenW,screenH));
		f.pack();

		//フレームに描画する準備
		image=canvas.createImage(screenW, screenH);
		fg=canvas.getGraphics();
		bg=image.getGraphics();

		//フィールド配列の初期化
		for(int row=0;row<FIELD_ROWS;row++) {
			for(int col=0;col<FIELD_COLS;col++) {
				if(row==FIELD_ROWS-1||col==0||col==FIELD_COLS-1) {
					field[row][col]=1;
				}else {
					field[row][col]=0;
				}
			}
		}

		//ブロック配列の初期化
		block= new int[][]{
			{1,1},
			{1,1}
			};

		//フィールド内のブロックの座標の指定
		x=FIELD_COLS/2-1;
		y=0;

		while(true) {
			//描画領域をクリア
			bg.clearRect(0, 0, screenW, screenH);
			//色をlightGrayに設定
			bg.setColor(Color.darkGray);
			//背景の描画
			bg.fillRect(0,0,screenW,screenH);
			//フィールドの描画
			for(int row=0;row<FIELD_ROWS;row++) {
				for(int col=0;col<FIELD_COLS;col++) {
					if(field[row][col]!=0) {
						//色をlightGrayに設定
						bg.setColor(Color.lightGray);
						//壁・床の描画
						bg.fillRect(col*CELL_SIZE, row*CELL_SIZE, CELL_SIZE-1, CELL_SIZE-1);
					}else {
						//色をblackに設定
						bg.setColor(Color.black);
						//壁・床の描画
						bg.fillRect(col*CELL_SIZE, row*CELL_SIZE, CELL_SIZE-1, CELL_SIZE-1);
					}
				}
			}

			//ブロックの描画
			for(int row=0;row<block.length;row++) {
				for(int col=0;col<block[row].length;col++) {
					if(block[row][col]!=0) {
						//色をredに設定
						bg.setColor(Color.red);
						//壁・床の描画
						bg.fillRect((col+x)*CELL_SIZE, (row+y)*CELL_SIZE, CELL_SIZE-1, CELL_SIZE-1);
					}
				}
			}

			//バッファ領域のイメージを描画領域へ転送
			fg.drawImage(image, 0, 0, canvas);
		}
	}

	public static void main(String[] args){
		new Tetris_002();
	}
}
